From d04922cd1a4cd3c3d67ddfc650dec99cc32198ed Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: May 19 2020 11:43:57 +0000
Subject: [PATCH 1/3] Ticket - 49562 integrate changelog database to main database


PHASE 2 of backend redesign:
http://www.port389.org/docs/389ds/design/integrate-changelog-database-and-backend-database.html

---

diff --git a/dirsrvtests/tests/suites/replication/changelog_test.py b/dirsrvtests/tests/suites/replication/changelog_test.py
index 48a0b39..e7362f0 100644
--- a/dirsrvtests/tests/suites/replication/changelog_test.py
+++ b/dirsrvtests/tests/suites/replication/changelog_test.py
@@ -73,7 +73,7 @@ def _create_changelog_dump(topo):
     """Dump changelog using nss5task and check if ldap operations are logged"""
 
     log.info('Dump changelog using nss5task and check if ldap operations are logged')
-    changelog_dir = topo.ms['master1'].get_changelog_dir()
+    changelog_dir = topo.ms['master1'].get_ldif_dir()
     replicas = Replicas(topo.ms["master1"])
     replica = replicas.get(DEFAULT_SUFFIX)
     log.info('Remove ldif files, if present in: {}'.format(changelog_dir))
diff --git a/ldap/admin/src/scripts/DSCreate.pm.in b/ldap/admin/src/scripts/DSCreate.pm.in
index a2f15f9..6ed2835 100644
--- a/ldap/admin/src/scripts/DSCreate.pm.in
+++ b/ldap/admin/src/scripts/DSCreate.pm.in
@@ -481,7 +481,7 @@ sub makeOtherConfigFiles {
         if ($!) {
             return ('error_copying_file', $src, $dest, $!);
         }
-        if (@errs = changeOwnerMode($inf, 4, $dest)) {
+        if (@errs = changeOwnerMode($inf, 6, $dest)) {
             return @errs;
         }
     }
diff --git a/ldap/admin/src/scripts/db2ldif.in b/ldap/admin/src/scripts/db2ldif.in
index f1b0826..169990d 100755
--- a/ldap/admin/src/scripts/db2ldif.in
+++ b/ldap/admin/src/scripts/db2ldif.in
@@ -25,6 +25,7 @@ usage()
     echo "        -x                - Suffix to exclude"
     echo "        -a outputfile     - Name of the exported LDIF file"
     echo "        -r                - Include replication data"
+    echo "        -R                - Include changelog data"
     echo "        -E                - Decrypt attributes"
     echo "        -u                - Do not export the nsUniqueId attribute"
     echo "        -U                - Do not wrap long lines"
@@ -100,7 +101,7 @@ then
     exit 1
 fi
 
-while getopts "hZ:vd:D:ENa:rs:x:CSut:n:UmMo1qVc:" flag
+while getopts "hZ:vd:D:ENa:rs:x:CSut:n:UmMo1qRVc:" flag
 do
     case $flag in
         h) usage
@@ -119,6 +120,7 @@ do
         S) args=$args" -S";;
         v) args=$args" -v";;
         r) args=$args" -r";;
+        R) args=$args" -R";;        
         C) args=$args" -C";;
         u) args=$args" -u";;
         U) args=$args" -U";;
diff --git a/ldap/admin/src/scripts/ldif2db.in b/ldap/admin/src/scripts/ldif2db.in
index e5ba43d..bb9925d 100755
--- a/ldap/admin/src/scripts/ldif2db.in
+++ b/ldap/admin/src/scripts/ldif2db.in
@@ -30,6 +30,7 @@ usage()
     echo "        -G name           - Namespace id for name based uniqueid (-g deterministic)"
     echo "        -O                - Do not index the attributes"
     echo "        -E                - Encrypt attributes"
+    echo "        -R                - Import changelog data"
     echo "        -q                - Quiet mode - suppresses output"
     echo "        -V                - Verbose output"
     echo "        -v                - Display version"
@@ -54,7 +55,7 @@ handleopts()
     return 0
 }
 
-while getopts "Z:vhd:i:g:G:n:s:x:NOCc:St:D:EqV" flag
+while getopts "Z:vhd:i:g:G:n:s:x:NOCc:St:D:ERqV" flag
 do
     case $flag in
         h) usage
@@ -71,6 +72,7 @@ do
         t) args=$args" -t \"$OPTARG\"";;
         D) args=$args" -D \"$OPTARG\"";;
         E) args=$args" -E";;
+        R) args=$args" -R";;
         v) args=$args" -v";;
         N) args=$args" -N";;
         C) args=$args" -C";;
diff --git a/ldap/servers/plugins/replication/cl5.h b/ldap/servers/plugins/replication/cl5.h
index 2af57e3..b7e3203 100644
--- a/ldap/servers/plugins/replication/cl5.h
+++ b/ldap/servers/plugins/replication/cl5.h
@@ -21,17 +21,18 @@
 typedef struct changelog5Config
 {
     char *dir;
-    /* These 2 parameters are needed for changelog trimming. Already present in 5.0 */
+    /* These 3 parameters are needed for changelog trimming. */
     char *maxAge;
     int maxEntries;
-    /* the changelog DB configuration parameters are defined as CL5DBConfig in cl5_api.h */
-    CL5DBConfig dbconfig;
-    char *symmetricKey;
-    long compactInterval;
     long trimInterval;
+    /* configuration of changelog encryption */
+    char *encryptionAlgorithm;
+    char *symmetricKey;
 } changelog5Config;
 
-/* initializes changelog*/
+/* upgrade changelog*/
+int changelog5_upgrade(void);
+/* initialize changelog*/
 int changelog5_init(void);
 /* cleanups changelog data */
 void changelog5_cleanup(void);
@@ -41,6 +42,11 @@ int changelog5_config_init(void);
 void changelog5_config_cleanup(void);
 /* reads changelog configuration */
 int changelog5_read_config(changelog5Config *config);
+/* transforms entry to internal config */
+void changelog5_extract_config(Slapi_Entry *entry, changelog5Config *config);
+/* registeri/unregister functions to handle config changes */
+int changelog5_register_config_callbacks(const char *dn, Replica *replica);
+int changelog5_remove_config_callbacks(const char *dn);
 /* cleanups the content of the config structure */
 void changelog5_config_done(changelog5Config *config);
 /* frees the content and the config structure */
